/* $NoKeywords:$ */
/**
 * @file
 *
 * AMD Family_14 Microcode patch.
 *
 * Fam14 Microcode Patch rev 0500000B for 5000 or equivalent.
 *
 * @xrefitem bom "File Content Label" "Release Content"
 * @e project:      AGESA
 * @e sub-project:  CPU/FAMILY/0x14
 * @e \$Revision: 34897 $   @e \$Date: 2010-07-14 10:07:10 +0800 (Wed, 14 Jul 2010) $
 *
 */
/*
 *****************************************************************************
 *
 * Copyright (c) 2011, Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Advanced Micro Devices, Inc. nor the names of
 *       its contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ADVANCED MICRO DEVICES, INC. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***************************************************************************
 *
 */
/*----------------------------------------------------------------------------------------
 *                             M O D U L E S    U S E D
 *----------------------------------------------------------------------------------------
 */
#include "AGESA.h"
#include "cpuRegisters.h"
#include "cpuEarlyInit.h"

/*----------------------------------------------------------------------------------------
 *                   D E F I N I T I O N S    A N D    M A C R O S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                  T Y P E D E F S     A N D     S T R U C T U R E S
 *----------------------------------------------------------------------------------------
 */

// Patch code 0500000B for 5000 and equivalent
CONST MICROCODE_PATCHES ROMDATA CpuF14MicrocodePatch0500000B =
{{
  0x10, 0x20, 0x01, 0x06, 0x0b, 0x00, 0x00, 0x05,
  0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x50, 0x00, 0x00, 0x00, 0xaa, 0xaa, 0xaa,
  0x67, 0xe5, 0x52, 0x3e, 0x6b, 0x1c, 0x70, 0x69,
  0xd9, 0x1c, 0x8d, 0xab, 0xab, 0xc4, 0xce, 0xc5,
  0x4f, 0xc9, 0x2d, 0x81, 0xeb, 0x2b, 0x49, 0x14,
  0x39, 0xc9, 0xea, 0xd1, 0x6e, 0x83, 0x4c, 0x14,
  0x6c, 0x57, 0x06, 0xf8, 0xcf, 0xa5, 0xb4, 0x4a,
  0xab, 0x40, 0x63, 0x38, 0x0c, 0x32, 0x56, 0x28,
  0x46, 0xe5, 0x2c, 0x62, 0x26, 0x54, 0xf7, 0xa2,
  0x45, 0xfe, 0xcb, 0x20, 0x01, 0xb1, 0x6d, 0x5d,
  0xbc, 0xe8, 0xf9, 0xe0, 0x4e, 0x11, 0x94, 0x1f,
  0x20, 0x90, 0x31, 0x33, 0x23, 0x09, 0xb4, 0xa4,
  0xc8, 0x88, 0xa4, 0x93, 0xee, 0x36, 0xe4, 0x18,
  0xb8, 0xbd, 0x66, 0x5a, 0x69, 0x03, 0x9c, 0xc0,
  0xc9, 0x44, 0x38, 0x29, 0xbe, 0xba, 0x4d, 0xa7,
  0x42, 0xac, 0xe3, 0x6a, 0xf9, 0xfa, 0xa9, 0x04,
  0xec, 0x93, 0x47, 0xf0, 0x1f, 0x49, 0xf1, 0xe7,
  0x69, 0x24, 0x4c, 0x88, 0x1e, 0xad, 0xc3, 0x57,
  0xec, 0x45, 0xd4, 0xeb, 0xd1, 0xdf, 0xdc, 0x04,
  0x3b, 0xc1, 0xb0, 0x8d, 0xa1, 0x3a, 0x4d, 0x79,
  0x4b, 0xad, 0x70, 0x9b, 0x3d, 0xcf, 0x7a, 0x8d,
  0xe1, 0xc2, 0xdb, 0x53, 0x0b, 0xbd, 0xf8, 0x94,
  0x7c, 0x2c, 0x4d, 0x50, 0xdf, 0x90, 0x31, 0x52,
  0x8f, 0xb4, 0xd6, 0x1e, 0x37, 0x3c, 0x98, 0x2b,
  0x26, 0x8f, 0x0a, 0x9c, 0x15, 0x8f, 0x62, 0x83,
  0x11, 0xbf, 0xc1, 0x74, 0xd7, 0x35, 0xa4, 0x82,
  0xba, 0xd3, 0xcb, 0xb6, 0xa0, 0xca, 0x7e, 0x23,
  0xaa, 0x12, 0x77, 0x24, 0xdb, 0xfb, 0x82, 0x4f,
  0x94, 0xee, 0xbe, 0xcd, 0x7a, 0x69, 0x63, 0xf6,
  0x7d, 0x31, 0xb7, 0x9a, 0xfa, 0xe5, 0xb3, 0x1d,
  0x39, 0xdb, 0x40, 0xba, 0x1b, 0xaf, 0xa9, 0xc9,
  0x24, 0xea, 0x78, 0x47, 0xf2, 0x19, 0x2b, 0x63,
  0x07, 0xe1, 0x4c, 0xa8, 0xdb, 0xff, 0x34, 0x07,
  0xe8, 0x1d, 0x75, 0xcc, 0x99, 0x41, 0xd1, 0x03,
  0xa4, 0xb9, 0x58, 0x53, 0xba, 0x80, 0x5c, 0xac,
  0x44, 0x26, 0xe2, 0xa7, 0xbf, 0x4f, 0xd9, 0x52,
  0xed, 0x36, 0xbc, 0xc3, 0xed, 0x39, 0x60, 0xc6,
  0x5d, 0x19, 0x4a, 0x4f, 0xea, 0x5b, 0x94, 0xee,
  0x8c, 0x63, 0x96, 0x61, 0x0e, 0xfd, 0x09, 0x7a,
  0xdb, 0xc1, 0x9c, 0x31, 0xc2, 0x64, 0xac, 0xbe,
  0xc6, 0x5a, 0x6b, 0x14, 0x60, 0x99, 0xd1, 0x39,
  0xda, 0xfc, 0x70, 0x2c, 0x96, 0x49, 0x5d, 0xb9,
  0xf1, 0xa4, 0x72, 0xcf, 0x4c, 0xa7, 0x7b, 0x4a,
  0xaa, 0x09, 0xf0, 0x36, 0xef, 0x6b, 0x7a, 0x76,
  0xe5, 0x8a, 0x69, 0x33, 0xb0, 0x34, 0x67, 0x61,
  0x85, 0xc9, 0xf9, 0x6e, 0x71, 0x84, 0xc5, 0x9b,
  0x1a, 0xdf, 0x56, 0x6d, 0x8a, 0xde, 0x25, 0x2c,
  0x6e, 0xcb, 0x94, 0x47, 0x86, 0x7c, 0x9d, 0x1e,
  0x40, 0xf3, 0xa1, 0x6b, 0xbc, 0x61, 0x68, 0x39,
  0x2e, 0x70, 0x4f, 0x65, 0x62, 0xe4, 0xba, 0xb6,
  0xf8, 0x69, 0x9b, 0x12, 0xd9, 0x88, 0xea, 0x02,
  0x42, 0x32, 0xa5, 0x51, 0x1e, 0x7c, 0x75, 0xe9,
  0xf2, 0xa6, 0x10, 0x87, 0x4e, 0xa3, 0x9a, 0xba,
  0x8f, 0xc7, 0x9f, 0x30, 0xd8, 0x8c, 0x22, 0x14,
  0xac, 0x15, 0x02, 0xd1, 0xf5, 0x28, 0xf1, 0xf7,
  0x34, 0x76, 0x89, 0x02, 0xd5, 0x71, 0x41, 0xbf,
  0x22, 0x13, 0xb6, 0x2d, 0xa9, 0x55, 0xf8, 0x5d,
  0x86, 0xf1, 0x80, 0xae, 0xa1, 0xa0, 0x82, 0xaf,
  0x89, 0x67, 0xcc, 0xf7, 0xc3, 0x5b, 0x67, 0x7c,
  0x7a, 0x53, 0xa7, 0x8a, 0xcd, 0x21, 0x75, 0x07,
  0x1f, 0xa5, 0xbd, 0x0a, 0x0a, 0xcc, 0xc0, 0x6b,
  0x22, 0xc7, 0x53, 0xbc, 0xbf, 0x7e, 0xaf, 0x89,
  0x52, 0x72, 0x11, 0xd1, 0x59, 0x8b, 0x6d, 0xbd,
  0xd5, 0x01, 0xeb, 0x75, 0x5b, 0x37, 0x03, 0x43,
  0x3f, 0x84, 0x8d, 0x54, 0x18, 0x53, 0x22, 0x4c,
  0x85, 0xfc, 0x2b, 0x70, 0x4e, 0xd9, 0x78, 0xcd,
  0xb0, 0xa1, 0x16, 0x0f, 0x08, 0xbd, 0x65, 0xd0,
  0x92, 0x61, 0x62, 0x69, 0x1e, 0xbb, 0xf0, 0xa5,
  0x7a, 0x9c, 0x1b, 0x7a, 0x68, 0xa9, 0xe8, 0x0a,
  0x17, 0x9d, 0x89, 0x3f, 0x48, 0x25, 0xd6, 0xe7,
  0xb8, 0xb9, 0x79, 0x2f, 0x53, 0x42, 0x12, 0xf4,
  0xc6, 0x83, 0x8d, 0x25, 0xf1, 0x43, 0x9d, 0x33,
  0x94, 0x99, 0xde, 0x49, 0x21, 0x93, 0xfc, 0x21,
  0xf0, 0x49, 0x5d, 0x0e, 0x2f, 0x76, 0xaf, 0x18,
  0xa3, 0xd1, 0x70, 0xdb, 0x9c, 0x35, 0x5c, 0x87,
  0x42, 0x76, 0x80, 0x4e, 0xd2, 0x8d, 0x71, 0x98,
  0x78, 0xeb, 0x7d, 0xfa, 0x39, 0x83, 0xd2, 0x4e,
  0xfe, 0xde, 0xc4, 0x8b, 0xef, 0x5f, 0xce, 0xf0,
  0x80, 0xdf, 0x18, 0x3c, 0xe2, 0xb7, 0xdc, 0xb0,
  0xf1, 0xc5, 0x42, 0xa7, 0x2c, 0x84, 0x9e, 0x4c,
  0xdd, 0x8c, 0x9c, 0x4a, 0xda, 0xf1, 0xcf, 0x18,
  0xc1, 0xb6, 0x6d, 0x40, 0x57, 0x3e, 0x26, 0x44,
  0xc7, 0xe7, 0xda, 0x9c, 0x0e, 0x3d, 0x80, 0x05,
  0xf8, 0x07, 0x5f, 0xfc, 0x72, 0x9b, 0x50, 0xe5,
  0x79, 0xaa, 0xf3, 0xd0, 0x7a, 0x0e, 0xb2, 0xd8,
  0xb5, 0x82, 0x5a, 0x04, 0x00, 0x8c, 0xd4, 0xb2,
  0x51, 0xc0, 0xb8, 0xec, 0xa5, 0x90, 0x21, 0xc3,
  0x1e, 0x17, 0x9b, 0x19, 0x26, 0xe9, 0x2a, 0x21,
  0x75, 0xe3, 0xa6, 0xd7, 0xd0, 0x5c, 0xb6, 0x36,
  0x8f, 0x51, 0x45, 0xe4, 0x85, 0x5f, 0xbf, 0xee,
  0xc4, 0x13, 0x38, 0xf0, 0x89, 0x1d, 0x61, 0xfa,
  0x01, 0x9e, 0xa6, 0xda, 0xd4, 0x7b, 0xa5, 0xa3,
  0x1a, 0x44, 0x1e, 0xa7, 0xca, 0x14, 0xb1, 0xc2,
  0xd0, 0x35, 0x03, 0xca, 0xf8, 0x18, 0x04, 0x24,
  0xae, 0xb1, 0xc2, 0xc2, 0x98, 0x3a, 0xd6, 0xdf,
  0xfb, 0x3c, 0x0d, 0x72, 0xdb, 0x85, 0x81, 0x4c,
  0x6f, 0xe5, 0x91, 0x20, 0xa1, 0x99, 0xb7, 0x07,
  0xde, 0x7c, 0x37, 0x0a, 0x18, 0x1d, 0x90, 0xa7,
  0x88, 0x7b, 0x15, 0xdc, 0x77, 0x86, 0xb2, 0xd9,
  0x90, 0xe9, 0x5c, 0x58, 0x51, 0x33, 0x06, 0x95,
  0xad, 0xbf, 0xdf, 0xc7, 0x4d, 0xcb, 0xec, 0x9f,
  0x6d, 0x00, 0xfa, 0x8f, 0x38, 0x4c, 0x56, 0x7e,
  0x1a, 0x09, 0x16, 0xd6, 0x2d, 0x4d, 0x50, 0xf5,
  0x54, 0x12, 0x8c, 0x64, 0x25, 0x07, 0xa7, 0xe2,
  0xeb, 0x48, 0xbd, 0x50, 0x84, 0x8e, 0x90, 0xb6,
  0x43, 0x00, 0x87, 0x63, 0x78, 0x73, 0xd1, 0xd5,
  0xf1, 0x80, 0xd8, 0x44, 0xbe, 0x8e, 0x45, 0xd6,
  0xec, 0xbc, 0xc5, 0xab, 0x97, 0x69, 0x38, 0xaa,
  0x23, 0x63, 0x76, 0xaa, 0x13, 0x7d, 0xa3, 0x82,
  0x83, 0x81, 0xdf, 0x53, 0x2e, 0x04, 0x69, 0x0f,
  0x6f, 0x41, 0x1d, 0x46, 0x96, 0x4d, 0x5b, 0x27,
  0xc9, 0x7b, 0x56, 0x8d, 0x86, 0x46, 0xd5, 0x74,
  0xaa, 0x16, 0x2d, 0x6d, 0x1a, 0xf6, 0xcf, 0x57,
  0x7c, 0xca, 0x3a, 0x98, 0x70, 0x61, 0xa5, 0x74,
  0x6b, 0x06, 0x44, 0x96, 0xcf, 0x46, 0x20, 0x9a,
  0x39, 0xcb, 0xf0, 0x84, 0x50, 0x93, 0xf0, 0xce,
  0x64, 0xe3, 0xaf, 0xdc, 0x1b, 0x21, 0x5f, 0xce,
  0xed, 0xb6, 0x85, 0xd4, 0x5c, 0x52, 0x71, 0x8c,
  0x05, 0xe0, 0x14, 0x76, 0xa1, 0x6e, 0xdc, 0x63,
  0x1c, 0xf7, 0xc1, 0x38, 0x29, 0xf3, 0x3e, 0xd2,
  0xb1, 0xb4, 0xc7, 0xd5, 0x8f, 0x63, 0xbc, 0x25,
  0xe2, 0x59, 0xb8, 0xf1, 0x51, 0x10, 0x3b, 0xec,
  0x49, 0x3a, 0xfc, 0x4a, 0x29, 0x7e, 0x1d, 0xa4,
  0xc4, 0xa3, 0xc1, 0x51, 0x90, 0x0e, 0x10, 0x94,
  0x1b, 0x60, 0xdd, 0xd0, 0x89, 0xf9, 0x76, 0xa6,
  0x1a, 0x7b, 0xba, 0x90, 0x85, 0x35, 0xea, 0xf9,
  0xca, 0x53, 0xd5, 0xa1, 0x87, 0x95, 0x52, 0xc2,
  0xc2, 0xa8, 0xc8, 0xb8, 0xe7, 0x05, 0xbf, 0x19,
  0xb0, 0x46, 0xe8, 0x44, 0x77, 0x80, 0x8f, 0xe0,
  0xee, 0xfd, 0x5b, 0xe2, 0x74, 0xed, 0x32, 0xab,
  0x0b, 0x54, 0xa7, 0x48, 0x8e, 0xc6, 0xa0, 0x09,
  0xf1, 0x62, 0x1b, 0xd1, 0x30, 0xa1, 0x9b, 0x3e,
  0x3d, 0x4b, 0xd0, 0x34, 0xb7, 0x7f, 0x51, 0x83,
  0x14, 0xa7, 0x36, 0xdd, 0xbc, 0x24, 0x74, 0x8d,
  0x92, 0xd6, 0x3b, 0x99, 0xec, 0x71, 0x59, 0xa5,
  0xa7, 0x72, 0x05, 0x83, 0x83, 0xb8, 0x88, 0x33,
  0xba, 0x7c, 0x51, 0x2c, 0x4f, 0x20, 0x33, 0xff,
  0x6a, 0x5e, 0x24, 0x9d, 0x93, 0x66, 0xc2, 0x0e,
  0x72, 0x5f, 0xdb, 0x50, 0x32, 0x00, 0x84, 0x9f,
  0x96, 0x86, 0xa7, 0x71, 0x62, 0x55, 0x78, 0x36,
  0x56, 0x2d, 0x94, 0x48, 0x46, 0xc2, 0x76, 0xaf,
  0x4b, 0x2a, 0x0a, 0xb6, 0x18, 0x0e, 0xf6, 0xa6,
  0xa8, 0xb2, 0x94, 0x9a, 0x39, 0xfd, 0xfa, 0x9a,
  0x6a, 0x19, 0x83, 0x1e, 0x78, 0x85, 0x59, 0x6b,
  0xdf, 0xf4, 0x93, 0x44, 0x2e, 0x01, 0x61, 0xe9,
  0x98, 0xa6, 0x28, 0xc9, 0x66, 0x9e, 0x1d, 0xb2,
  0xe2, 0x44, 0x16, 0xdc, 0x86, 0xca, 0xf0, 0x03,
  0x2e, 0xd1, 0x5d, 0x06, 0x30, 0xa3, 0x27, 0xc2,
  0x84, 0x42, 0x70, 0x25, 0x0f, 0xd2, 0x4e, 0x02,
  0x90, 0x88, 0xe6, 0x90, 0x83, 0xac, 0x42, 0x00,
  0x61, 0x05, 0x1e, 0x46, 0xfa, 0xae, 0x91, 0xd9,
  0xe8, 0xa3, 0x28, 0xfb, 0x7c, 0xd6, 0x38, 0x77,
  0x9c, 0xfc, 0xbd, 0xb4, 0x74, 0x07, 0x7c, 0x60,
  0xa5, 0xf2, 0xe8, 0xc7, 0x83, 0xfa, 0x0f, 0x47,
  0xf8, 0x63, 0xe7, 0x3e, 0x95, 0x34, 0x16, 0xce,
  0x24, 0x93, 0x0e, 0xd4, 0x14, 0xe7, 0x01, 0x48,
  0xeb, 0x7d, 0xfe, 0x6f, 0x20, 0xcd, 0x42, 0x79,
  0xb4, 0x0b, 0xa0, 0x6e, 0xe7, 0x5b, 0x68, 0xba,
  0x21, 0x56, 0x65, 0x3a, 0x51, 0xa2, 0xec, 0x3b,
  0xb1, 0xec, 0x61, 0xf8, 0x70, 0x65, 0x5c, 0x9b,
  0xf6, 0xd4, 0xb1, 0xe0, 0xd4, 0x73, 0x92, 0x54,
  0x6f, 0x6f, 0xf8, 0x17, 0x24, 0x10, 0x82, 0xba,
  0x2e, 0x95, 0xbd, 0x69, 0x9f, 0xb3, 0xb0, 0xf0,
  0x57, 0x15, 0x8c, 0x2f, 0x44, 0x4e, 0x83, 0xc9,
  0xf3, 0xa1, 0xc9, 0x39, 0xe8, 0x3c, 0xb0, 0xa7,
  0x51, 0x69, 0xce, 0x4b, 0xb2, 0x70, 0x3e, 0x8e,
  0xcf, 0x3e, 0x3a, 0x95, 0x5e, 0x18, 0x43, 0xc9,
  0xde, 0x4e, 0x47, 0xbb, 0x6e, 0x0c, 0x83, 0x3b,
  0xaf, 0x58, 0x67, 0x06, 0xd6, 0x52, 0xd5, 0x89,
  0xb7, 0x1c, 0xb9, 0xd9, 0xa3, 0x95, 0x81, 0x92,
  0x8b, 0x32, 0x43, 0xb9, 0xf8, 0x99, 0x2e, 0x70,
  0xc9, 0x1e, 0x9a, 0x3a, 0xaa, 0x97, 0xd8, 0xcc,
  0x2f, 0xd2, 0x69, 0xdc, 0x69, 0xab, 0x63, 0xc0,
  0x5f, 0xd5, 0xb6, 0xb8, 0x8b, 0x8d, 0x6c, 0x15,
  0x56, 0x0a, 0xe6, 0x92, 0xb5, 0x25, 0x4b, 0x24,
  0x1c, 0x63, 0x5f, 0x0c, 0x1d, 0x36, 0x6e, 0x7a,
  0xc0, 0x5b, 0xdb, 0xa1, 0xf8, 0x16, 0x29, 0x04,
  0x2f, 0x2b, 0xb8, 0x11, 0xf9, 0xef, 0x1a, 0x50,
  0x0c, 0x97, 0x19, 0x20, 0xbc, 0xe9, 0x40, 0xd1,
  0x0b, 0x74, 0xec, 0xa0, 0xd5, 0x18, 0x6b, 0xc8,
  0x6e, 0xb1, 0x65, 0xd7, 0x5f, 0xf3, 0x7c, 0x33,
  0x89, 0xca, 0x15, 0xd1, 0xa8, 0x7f, 0x73, 0xe0,
  0xa2, 0x72, 0x27, 0x6d, 0x79, 0xa5, 0xec, 0x36,
  0x4e, 0x47, 0xd1, 0x52, 0xe4, 0x0f, 0x3b, 0x9a,
  0xb5, 0xef, 0x97, 0x0f, 0xc5, 0x9c, 0x7a, 0x51,
  0xbe, 0x23, 0x0f, 0x15, 0x87, 0xd0, 0xa5, 0xf6,
  0x12, 0x81, 0xdd, 0x44, 0xd9, 0xf4, 0xcc, 0xda,
  0x61, 0x5e, 0x66, 0xa4, 0xf1, 0x7c, 0xd7, 0xd3,
  0xac, 0xf0, 0x57, 0xd0, 0x53, 0xeb, 0x19, 0xbd,
  0x9d, 0xb4, 0xcb, 0x9e, 0x61, 0x1e, 0xe2, 0x0e,
  0xdb, 0x6d, 0x40, 0xaa, 0xe8, 0xc8, 0x91, 0xec,
  0xca, 0xb0, 0x0f, 0xf1, 0x41, 0x71, 0x43, 0x25,
  0x71, 0xf5, 0xab, 0x93, 0x03, 0xa7, 0x64, 0xdb,
  0xb4, 0xde, 0x11, 0x4f, 0x08, 0xe9, 0xb2, 0x6d
}};

/*----------------------------------------------------------------------------------------
 *           P R O T O T Y P E S     O F     L O C A L     F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                          E X P O R T E D    F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */
